// Copyright 6/4/2019 Varjo Technologies Oy. All Rights Reserved.

#pragma once

#include "IEyeTrackerModule.h"
#include "EyeTrackerTypes.h"
#include "IEyeTracker.h"
#include "IVarjoVREyeTracker.h"
#include "VarjoEyeTrackerTypes.h"
#include "Containers/Ticker.h"
#include "Tickable.h"
#include "GameFramework/HUD.h"
#include "../../VarjoHMD/Private/VarjoHMD.h"

class VarjoTestGaze: public IVarjoVREyeTracker
{
public:
	const FVarjoEyeTrackingData& GetEyeTrackingData() override;
	EVarjoEyeTrackingStatus GetEyeTrackingStatus() override { return EVarjoEyeTrackingStatus::Calibrated; }

	void getRay(FVector& start, FVector& direction, float& focusDistance) override;
	bool getEyeTrackingData(TArray<FVarjoEyeTrackingData>& trackingData) override { return false; }
	void requestGazeCalibration() override { ; }
	bool getGazeArray(TArray<varjo_Gaze>& gazeData) override { return false; }
	bool Init() override { return true;  }
	void SetActivePlayerController(APlayerController* NewActivePlayerController) override { ; }
	APlayerController* GetActivePlayerController() const { return ActivePlayerController.Get(); }
	EVarjoEyeTrackingCalibrationStatus GetCalibrationStatus() override { return EVarjoEyeTrackingCalibrationStatus::Good; }
	void EnableDebugView(bool enable) override { ; }
	const FVector GetFixationPoint() override { return FVector::ZeroVector; }

private:
	FVarjoEyeTrackingData m_eyeTrackingData;
	TWeakObjectPtr<APlayerController> ActivePlayerController;
};
